<template>
<div class="wrapper wrapper-content animated fadeInRight">
    <div class="row">
        <div class="col-lg-12">
            <div class="ibox float-e-margins">
                <div class="ibox-title">
                    <h5>List Of Tool</h5>
                    <div class="ibox-tools">
                        <a class="btn btn-primary btn-xs" @click="modal_show()">
                            Add Tool
                        </a>
                        <a @click="load_tool()">
                            <i class="fa fa-refresh"></i>
                        </a>
                    </div>
                </div>
                <!-- /.ibox-titel -->
                
                <div class="ibox-content">
                    <!-- Search and filter form -->
                    <div class="row">
                        <div class="col-lg-12">
                            <div class="pull-left form-inline">
                                <label>Show 
                                    <input type="number" v-model="show_row" class="form-control input-sm" 
                                            style="width:60px;" min="1" max="1000">
                                </label>


                                <label>&nbsp;&nbsp;Limit
                                    <input type="number" v-model="limit" class="form-control input-sm" 
                                            style="width:70px;" min="1" max="1000">
                                </label>
                            </div>

                            <div class="pull-right form-inline">
                                <label>Search:
                                    <input v-model="search_key" class="form-control input-sm">
                                </label>&nbsp;
                            </div>
                        </div>
                    </div>
                    <!-- /.row -->
                
                    <div class="row" v-if=" tools.total">
                        <div class="col-lg-12">
                            <div>
                                <div>
                                    <p class="pull-left" style="margin-top: 7px;">
                                        Showing  {{ tools.from }} to  {{ tools.to }}  of  {{ tools.total }} entries.
                                    </p>
                                </div>
                                <div class="table_pagination">
                                    <div class="btn-group pull-right pagination pagination-sm no-margin" style="margin:-0px;">
                                
                                        <a class="btn btn-white btn-sm" 
                                            v-bind:class="{ disabled : ! tools.prev_page_url }" 
                                            @click=" gen_uri( tools.prev_page_url )"
                                        >
                                            <span>Prev</span>
                                        </a>  
                                        <a class="btn btn-white btn-sm" 
                                            v-bind:class="{ disabled : ! tools.first_page_url }" 
                                            @click=" gen_uri( tools.first_page_url )">
                                            <span>First</span>
                                        </a>
                                        <a class="btn btn-white btn-sm disabled"><span>...</span></a>
                                        <a class="btn btn-white btn-sm" 
                                            v-bind:class="{ disabled : ! tools.last_page_url }" 
                                            @click=" gen_uri( tools.last_page_url)">
                                        <span>Last</span>
                                        </a>
                                        <a class="btn btn-white btn-sm" 
                                            v-bind:class="{ disabled : ! tools.next_page_url }" 
                                            @click=" gen_uri( tools.next_page_url )"
                                        >
                                        <span>Next</span>
                                        </a>
                                    </div>
                                </div>        
                            </div>
                        </div>
                    </div>
                    <!-- /.row -->

                    <!-- Table -->
                    <div class="project-list table-responsive">
                        <table class="table table-stripped">
                            <thead>
                                <tr>
                                    <th class="text-center">#</th>
                                    <th>Code</th>
                                    <th>Description</th>
                                    <th>Brand #</th>
                                    <th>&nbsp;</th>
                                </tr>
                            </thead>
                            <tbody v-if="loading">
                                <tr>
                                    <td colspan="8">
                                        <spinner></spinner>
                                    </td>
                                </tr>
                            </tbody>
                            <tbody  v-else-if=" tools.data.length">
                                <tool-table v-for="(tool, row) in tools.data" 
                                            :key="tool.id" 
                                            :tool="tool" 
                                            :row="row"
                                            v-on:edit="modal_show"
                                >
                                </tool-table>
                            </tbody>
                            <tbody v-else>
                                <tr>
                                    <td colspan="8" class="text-center">
                                        No Result!
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <!-- /.table-responsive -->
                </div>
                <!-- /.ibox-content -->
            </div>
        </div>
    </div>

    <tool-modal v-on:save="tool_store" v-bind:modal="modal"></tool-modal>
</div>

<!-- /.wrapper wrapper-content animated fadeInRight -->
</template>

<script>
import axios from 'axios'
import Table from './Table.vue'
import Modal from './Modal.vue'
import Spinner from '../../other/Spinner.vue'
import appService from '../../../app.service.js'

export default {
    components: {
        'tool-modal': Modal,
        'tool-table': Table,
        'spinner': Spinner
    },
    data () {
        return {
            loading: false,
            search_key: '',
            show_row: 10,
            limit: 100,
            uri: '',
            tools: [],
            modal: { 
                is_update: false,
                pause_save: false,
                errors: '',
                data: {
                    code: '',
                    description: '',
                    brand: '',
                    id: ''
                }
            },
        }
    },
    methods: {
        load_tool () {
            this.loading = true
            let uri = this.uri
            axios.get(uri).then((response,reject) => {
                this.tools = response.data.tools
                this.loading = false
            }).catch(response => {
                reject(response.status)
                this.loading = false
            })
        },
        gen_uri (qry_page = '') {
            let query = {
                base: 'tool',
                page: qry_page.substr(1),
                show_row: this.show_row,
                limit: this.limit,
                search_key: this.search_key,
            }
            this.uri = appService.crud.generate_url( query ) 
            this.$router.push( this.uri )
        },
        modal_show( row_data ) {
            this.option_update()
            this.modal.errors = ''

            if(row_data) {
                this.modal.data = {
                    code: row_data.code,
                    description: row_data.description,
                    brand: row_data.brand_id,
                    id: row_data.id,
                }
            }else{
                this.modal.data = {
                    code: '',
                    description: '',
                    brand: '',
                    id: '',
                }
            }

            $('#tool_modal').modal('show');
        },
        tool_store( data ) {
            this.modal.pause_save = true
            appService.crud.store( '/tool', data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#tool_modal').modal('hide')
                    toastr.success( response.message, 'Saved!' )
                    this.load_tool()
                }
                this.modal.pause_save = false
            })
        },
        option_update: async function() {
            await this.$store.dispatch('optionListModule/update_options')
        }
    },  
    watch: {
        '$route' (to, from) {
            this.load_tool()
        },
        show_row: function () {
            this.loading = true
            this.gen_uri()
        },
        limit: function () {
            this.loading = true
            this.gen_uri()
        },
        search_key: function () {
            this.loading = true
            setTimeout(() => {
                this.gen_uri()
            }, 1500)
        }
    },
    created () {
        this.gen_uri()
        this.load_tool()
        this.option_update()
    }
}
</script>